KEY_B           EQU       0
KEY_H           EQU       1
KEY_Y           EQU       2
KEY_6           EQU       3
KEY_5           EQU       4
KEY_T           EQU       5
KEY_G           EQU       6
KEY_V           EQU       7
KEY_N           EQU       8
KEY_J           EQU       9
KEY_U           EQU     #0A
KEY_7           EQU     #0B
KEY_4           EQU     #0C
KEY_R           EQU     #0D
KEY_F           EQU     #0E
KEY_C           EQU     #0F
KEY_M           EQU     #10
KEY_K           EQU     #11
KEY_I           EQU     #12
KEY_8           EQU     #13
KEY_3           EQU     #14
KEY_E           EQU     #15
KEY_D           EQU     #16
KEY_X           EQU     #17
KEY_SS          EQU     #18
KEY_L           EQU     #19
KEY_O           EQU     #1A
KEY_9           EQU     #1B
KEY_2           EQU     #1C
KEY_W           EQU     #1D
KEY_S           EQU     #1E
KEY_Z           EQU     #1F
KEY_SP          EQU     #20
KEY_EN          EQU     #21
KEY_P           EQU     #22
KEY_0           EQU     #23
KEY_1           EQU     #24
KEY_Q           EQU     #25
KEY_A           EQU     #26
KEY_CS          EQU     #27

STR_KEYREAD:

DEFB 'BHY65TGVNJU74RFCMKI83EDX','Z'+5,'LO92WSZ','Z'+6,'Z'+7,'P01QA', 'Z'+4

JOYSTICK_TRIGGER:
     exx
     call READ_JOYSTICK
     exx

     ld hl, JOYSTICK
     ld a, (hl)

     ld (hl), 0
     ld c, a
     ld a, (JOYTRIGGER)
     cp c
     ret z

     ld a, c
     ld (JOYTRIGGER), a
     ld (hl), a
     ret
; WAITFORNOKEY: Espera a que no se est pulsando ninguna tecla

WAITFORNOKEY:
    push af
WAITFORNOKEY1:
    xor a
    in a, (#FE)
    cpl
    and #1f
    jr nz, WAITFORNOKEY1
    pop af
    ret

; WAITFORKEY: Espera a que se pulse una tecla

;WAITFORKEY:
;    call WAITFORNOKEY
;    push af
;WAITFORKEY1:
;    xor a
;    in a, (#FE)
;    cpl
;    and #1f
;    jr z, WAITFORKEY1
;    pop af
;    ret


WAITFORKEY:
;     push af
;     push bc
     call READ_JOYSTICK
     call JOYSTICK_TRIGGER


     xor a
     in a, (#FE)
     cpl
     and #1f
     ld b, a

     WAITFORKEY1:

     call JOYSTICK_TRIGGER
     ld a, (JOYSTICK)
     and a
     ret nz
;     jp nz, WFK_Exit


     xor a
     in a, (#FE)
     cpl
     and #1f
     jp nz, WAITFORKEY2
     ld b, a

     WAITFORKEY2:

     xor a
     in a, (#FE)
     cpl
     and #1f
     xor b
     jr z, WAITFORKEY1

;     WFK_Exit:

;     pop bc
;     pop af
;     ret


KFIND:
     call KFIND1
     ld a, d
     cp #ff
     ret z

     ld e, d
     ld d, 0
     ld hl, STR_KEYREAD
     add hl, de
     ret

KFIND1:
     ld de, #ff2f
     ld bc, #fefe

NXHALF:
     in a, (c)
     cpl
     and #1f
     jr z, NPRESS

     inc d
     ret nz

     ld h,a
     ld a,e
KLOOP:
     sub 8
     srl h
     jr nc, KLOOP

     ret nz

     ld d,a

NPRESS:
     dec e
     rlc b
     jr c, NXHALF

     cp a
     ret z


; KTEST1
; ENTRADA: A = Valor del scancode de la tecla
; SALIDA: NOCARRY si est pulsada, CARRY si no lo est (y BC = 0 si no lo est)
; Se conservan HL y DE

KTEST1:
     ld c, a
     and 7
     inc a
     ld b,a
     srl c
     srl c
     srl c
     ld a,5
     sub c
     ld c,a
     ld a, #fe
HIFIND:
     rrca
     djnz HIFIND

     in a, (#fe)
NXKEY:
     rra
     dec c
     jr nz, NXKEY
     ret
